#include "primes.h"
#include <jni.h>
#include <math.h>
#define lengthLPREF  5761455
static long LP[lengthLPREF];
long indexLastLP =-1;

long generatePrimes(long hasta)
{
        indexLastLP=-1;
	long n=0;
        if (indexLastLP==-1)
	{
		indexLastLP = 0;
		LP[indexLastLP]=2;
	}
        long lastPrime =LP[indexLastLP];
	for(n=lastPrime+1;n<=hasta;n++)
	{	
		if (isPrime(n))
		{
			indexLastLP++;
			LP[indexLastLP]=n;			
		}
	  	
	}
	return (indexLastLP+1);
}

/* This function calculates (a^b)%MOD */
long powMod(long a, long b, long MOD) {
long x = 1, y = a;
	while(b > 0) {
		if(b%2 == 1) {
			x=(x*y);
			if(x>MOD) x%=MOD;
		}
		y = (y*y);
		if(y>MOD) y%=MOD;
		b /= 2;
	}
	return x;
}

int fermat(long n)//1 no primo seguro
{
 int noprimo=0;
//http://www.wikihow.com/Check-if-a-Number-Is-Primehttp://www.wikihow.com/Check-if-a-Number-Is-Prime
 int a;
//1

//2
  #if 0
//3
  a=2;
  long exponente = n;
  long potencia = 1;
  long potencia_temporal = a;

//4
  //long potencia= exp(a,n)%n; // mejorado para a=2
  while (exponente>0) {
    if(exponente%2) {
      potencia *= potencia_temporal;
      if(potencia>n)
        potencia = potencia%n;
    }
    potencia_temporal = potencia_temporal*potencia_temporal;// << 1; // *2
 //	potencia_temporal = potencia_temporal*a;
    if(potencia_temporal>n)
      potencia_temporal = potencia_temporal%n;
    
    exponente = exponente >> 1;
  }
#endif
a=2;
long potencia=powMod(a,n, n);
//5
  if (potencia!=a)
       noprimo=1;
  return noprimo;
}


int isPrime(long n)
{
	if(n<=LP[indexLastLP])
	   return buscar(n, 0, indexLastLP);
       // if (fermat(n))
        //   return 0;		
        
        int isprime = 1;
	long c=0;
	long divisor =0;
	float raiz=sqrt(n);
	for (c=0;c<=indexLastLP;c++)
	{
		divisor = LP[c];
		if (divisor>raiz)
		{
			isprime =1;break;
		}
		long remainder = n%divisor;
		if (remainder==0)
		{
			isprime =0;break;
		}
	}
	return isprime;
   
}
int buscar(long key, long imin, long imax)
{
  // continue searching while [imin,imax] is not empty
  while (imax >= imin)
    {
      /* calculate the midpoint for roughly equal partition */
     // int imid = midpoint(imin, imax);
       long imid = floor((imax+imin)/2);
 
      // determine which subarray to search
      if      (LP[imid] <  key)
        // change min index to search upper subarray
        imin = imid + 1;
      else if (LP[imid] > key )
        // change max index to search lower subarray
        imax = imid - 1;
      else
        // key found at index imid
        //return imid;
	return 1;
  }
  // key not found
  return 0;
}
int  computeComb(long n, long* nmin, long* nMax, long* nComb)
{
    int ret =0;
    long i=0;
	/*if (n>2*LP[indexLastLP])
	{
		*nmin=-1;*nMax=-1;*nComb=0;
		ret=-1;
		return ret;
	}*/
	*nComb=0;
	*nMax=-1;
        long n2Max=-1;
        float fraccion=n/2;
	for(i=0;i<=indexLastLP;i++)
	{
	    long n1,n2;
            n1=LP[i];
           if (n1>fraccion)
		break;
	    if (n1==n2Max)
		break;
	    n2=n-n1;
            //Comprobamos si n2 es primo
            int isprime = isPrime(n2);
	    if (isprime)
	    {
		//Actualizo los valores de salida
 		*nComb=*nComb+1;
		if((*nmin<0)||(n1<*nmin))
			*nmin=n1;
		if((*nMax<0)||(n1>*nMax))
			*nMax=n1;
                if(n2>n2Max)
			n2Max=n2;
		if(n1>n2Max)
			n2Max=n1;	
            }

	
	}	
    return ret;
}
